/*
    _fade
    version 1.0 Copyright (C) 2007 Tagata Akira

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
    02110-1301 USA

*/

/****************************************************************
  Warning.  This program specifications including API may change
  because of beta version.
****************************************************************/

_fss._fade = function (elt,period,fadeout,interval,depthEnd,depthStart) {
	this.elt = elt;
	if (period != undefined)
		this.period = period;
	if (fadeout)
		this.fadeout = fadeout;
	if (interval != undefined)
		this.interval = interval;
	if (depthEnd)
		this.depthEnd = depthEnd;
	if (depthStart)
		this.depthStart = depthStart;
	this.n = 0;
	this.max = this.period/this.interval;
	this.initInterval(this.interval,function() {
		if (++this.n > this.max) {
			this.clearInterval();
			this.n = 0;
			this.complete();
			if (this.fadeout)
				this.elt.style.display = 'none';
			_fss.opacity(this.elt,this.depthEnd);
		}
		else {
			var opacity = this.depthStart + this.n / this.max * this.depthEnd;
			if (this.fadeout) opacity = 1 - opacity;
			_fss.opacity(this.elt,opacity);
			if (!this.fadeout && this.n == 1)
				this.elt.style.display = 'block';
		}
	},this);
	this.start = function(complete) {
		if (complete)
			this.complete = complete;
		this.setInterval();
	};
};

_fss._fade.prototype = _fss.createUnit();
_fss._fade.prototype.period = 1000;
_fss._fade.prototype.fadeout = false;
_fss._fade.prototype.complete = function () { };
_fss._fade.prototype.interval = 50;
_fss._fade.prototype.depthEnd = 1.0;
_fss._fade.prototype.depthStart = 0;
_fss._fade.prototype.terminateFade = function () { this.n = this.max; };
_fss._fade.prototype.finalOpacity = function () { _fss.opacity(this.elt,this.depthEnd); }

//-fxref-// _fss._fade: _fss.opacity _fss.createUnit