/*
    fio
    version 1.0 Copyright (C) 2007 Tagata Akira

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
    02110-1301 USA

*/

/****************************************************************
  Warning.  This program specifications including API may change
  because of beta version.
****************************************************************/

_fio.prototype = new _fss('fio','fade in out','1.0beta','2007 Tagata Akira','http://www.tagata.org/software/');

//-fxref-// _fio: _fss

_fio.prototype.waitIn = 5000;
_fio.prototype.timeIn = 3000;
_fio.prototype.waitOut = 9000;
_fio.prototype.timeOut = 1000;

// default option
_fio.prototype.option = {
	detectWaitFadeIn:	'cancelWaitFadeIn, noFadeIn, noWaitFadeOut, noFadeOut',
	detectFadeIn:		'noCancelFadeIn, noWaitFadeOut, fadeOut',
	detectWaitFadeOut:	'cancelWaitFadeOut, fadeOut',
	detectFadeOut:		'noCancelFadeOut'
};

//
// option object
//
//	(detectWaitFadeIn: '( noCancelWaitFadeIn | cancelWaitFadeIn )
//			( fadeIn | noFadeIn )
//			( waitFadeOut | noWaitFadeOut )
//			( fadeOut | noFadeOut )'
//		|)
//
//	(detectFadeIn: '( noCancelFadeIn | cancelFadeIn )
//			( waitFadeOut | noWaitFadeOut )
//			( fadeOut | noFadeOut )'
//		|)
//
//	(detectWaitFadeOut: '( noCancelWaitFadeOut | cancelWaitFadeOut )
//			( fadeOut | noFadeOut )'
//		|)
//
//	(detectFadeOut: '( noCancelFadeOut | cancelFadeOut )'
//		|)
//

function _fio(elt,waitIn,timeIn,waitOut,timeOut,option) {

// |wait........|fadein.......|wait.........|fadeout.....|
//  setTimeout   setInterval   setTimeout    setInterval
//              clearTimeout  clearInterval clearTimeout clearInterval

	if (waitIn != undefined)  this.waitIn  = waitIn;
	if (timeIn != undefined)  this.timeIn  = timeIn;
	if (waitOut != undefined) this.waitOut = waitOut;
	if (timeOut != undefined) this.timeOut = timeOut;

	if (option) this.option = option;

	// detect option
	this.option.detect = {
		waitFadeIn: {
			noCancelWaitFadeIn: false,
			noFadeIn: false,
			noWaitFadeOut: false,
			noFadeOut: false
		},
		fadeIn: {
			noCancelFadeIn: false,
			noWaitFadeOut: false,
			noFadeOut: false
		},
		waitFadeOut: {
			noCancelWaitFadeOut: false,
			noFadeOut: false
		},
		fadeOut: {
			noCancelFadeOut: false
		}
	};
	if (this.option.detectWaitFadeIn) {
		if (this.option.detectWaitFadeIn.indexOf('noCancelWaitFadeIn') != -1)
			this.option.detect.waitFadeIn.noCancelWaitFadeIn = true;
		if (this.option.detectWaitFadeIn.indexOf('noFadeIn') != -1)
			this.option.detect.waitFadeIn.noFadeIn = true;
		if (this.option.detectWaitFadeIn.indexOf('noWaitFadeOut') != -1)
			this.option.detect.waitFadeIn.noWaitFadeOut = true;
		if (this.option.detectWaitFadeIn.indexOf('noFadeOut') != -1)
			this.option.detect.waitFadeIn.noFadeOut = true;
	}
	if (this.option.detectFadeIn) {
		if (this.option.detectFadeIn.indexOf('noCancelFadeIn') != -1)
			this.option.detect.fadeIn.noCancelFadeIn = true;
		if (this.option.detectFadeIn.indexOf('noWaitFadeOut') != -1)
			this.option.detect.fadeIn.noWaitFadeOut = true;
		if (this.option.detectFadeIn.indexOf('noFadeOut') != -1)
			this.option.detect.fadeIn.noFadeOut = true;
	}
	if (this.option.detectWaitFadeOut) {
		if (this.option.detectWaitFadeOut.indexOf('noCancelWaitFadeOut') != -1)
			this.option.detect.waitFadeOut.noCancelWaitFadeOut = true;
		if (this.option.detectWaitFadeOut.indexOf('noFadeOut') != -1)
			this.option.detect.waitFadeOut.noFadeOut = true;
	}
	if (this.option.detectFadeOut) {
		if (this.option.detectFadeOut.indexOf('noCancelFadeOut') != -1)
			this.option.detect.fadeOut.noCancelFadeOut = true;
	}

	elt.$_fioObj = this;

	function wakeup(sleep,go,obj,waiting) {
		this.wait = _fss.createUnit();
		this.wait.initTimeout();
		this.wait.setTimeout(sleep,go,obj);
		this.wait[waiting] = true;
	}
//-fxref-// _fio: _fss.createUnit
	function fadeOut(ftu) {
		ftu.waitingOut = false;
		this.$_fioObj._log('fadeOut(): '+'timeOut:'+this.$_fioObj.timeOut);
		ftu.fo = new _fss._fade(this,this.$_fioObj.timeOut,true);
//-fxref-// _fio: _fss._fade
		ftu.fo.elt = this;
		ftu.fo.start(function () {
			this.fadingOut = false;
			this.elt.$_fioObj.fadeClearedAlready = true;
			this.elt.$_fioObj._log('fadeOut() completed');
		});
		ftu.fo.fadingOut = true;
	}
	function fadeIn(ftu) {
		ftu.waitingIn = false;
		this.$_fioObj._log('fadeIn(): '+'timeIn:'+this.$_fioObj.timeIn);
		ftu.fo = new _fss._fade(this,this.$_fioObj.timeIn);
		ftu.fo.elt = this;
		ftu.fo.start(fadeInComplete);
		ftu.fo.fadingIn = true;
	}
	function fadeInComplete() {
		this.fadingIn = false;
		this.elt.$_fioObj._log('fadeInComplete(): '+'waitOut:'+this.elt.$_fioObj.waitOut);
		wakeup.call(this,this.elt.$_fioObj.waitOut,fadeOut,this.elt,'waitingOut');
	}
	wakeup.call(this,this.waitIn,fadeIn,elt,'waitingIn');

	this.fadeClear = function (ofio,halt) {
		this._log('fadeClear(): entered halt:'+halt);
		if (this.finished()) {
			this._log('fadeClear(): fadeClearedAlready:'+this.fadeClearedAlready+', halted:'+this.halted);
			return;
		}

		ftu = ofio.wait;

		if (ftu.statusTimeout('clear') || ftu.statusTimer('wrapped')) {
			if (ftu.fo) {
				if (ftu.fo.statusInterval('clear')) {
					this._log('fadeClear(): statusInterval() cleared');
					if (ftu.fo.wait)
						this.fadeClear(ftu.fo,halt);
					else
						this._log('fadeClear(): bypassed: no fo(fade object)');
				}
				else { // fading...
					if (halt) {
						ftu.fo.clearInterval();
						ftu.fo.finalOpacity();
						this._log('fadeClear(): halt:'+halt+' called clearInterval()');
						return (this.halted = true);
					}
					else if (this.option.detect.fadeIn && ftu.fo.fadingIn
						|| this.option.detect.fadeOut && ftu.fo.fadingOut) {
						if (ftu.fo.fadingIn) {
							if (this.option.detect.fadeIn.noWaitFadeOut)
								this.waitOut = 0;
							if (this.option.detect.fadeIn.noFadeOut)
								this.timeOut = 0;
						}
						else { // ftu.fo.fadingOut
						}

						if (this.option.detect.fadeIn && !this.option.detect.fadeIn.noCancelFadeIn
							|| this.option.detect.fadeOut && !this.option.detect.fadeOut.noCancelFadeOut) {
							ftu.fo.terminateFade();
							this._log('fadeClear(): called terminateFade()');
						}
					}
				}
			}
			else {
				this._log('fadeClear(): bypassed: no fo(fade object)');
			}
		}
		else { // waiting...
			if (halt) {
				ftu.tHandler = function () {};
				ftu.terminateTimeout();
				this._log('fadeClear(): halt:'+halt+' called terminateTimeout()');
				return (this.halted = true);
			}
			else if (this.option.detect.waitFadeIn && ftu.waitingIn
				|| this.option.detect.waitFadeOut && ftu.waitingOut) {
				if (ftu.waitingIn) {
					if (this.option.detect.waitFadeIn.noFadeIn)
						this.timeIn  = 0;
					if (this.option.detect.waitFadeIn.noWaitFadeOut)
						this.waitOut = 0;
					if (this.option.detect.waitFadeIn.noFadeOut)
						this.timeOut = 0;
				}
				else { // ftu.waitingOut
					if (this.option.detect.waitFadeOut.noFadeOut)
						this.timeOut = 0;
				}
				if (this.option.detect.waitFadeIn && !this.option.detect.waitFadeIn.noCancelWaitFadeIn
					|| this.option.detect.waitFadeOut && !this.option.detect.waitFadeOut.noCancelWaitFadeOut) {
					ftu.terminateTimeout();
					this._log('fadeClear(): called terminateTimeout()');
				}
			}
		}
		this._log('fadeClear(): exit');
	}

	this.cancel = function (halt) { this.fadeClear(this,halt); };
	this.finished = function () { return this.fadeClearedAlready || this.halted; };

	_fio.prototype._fssInsertUrl();
}
