// 2007-08-10

//_fss.prototype.parseClass = function (elt,classNames,f) {
//_fss.parseClass = function (elt,classNames,f) {
_fss.parseClass = function (elt,classNames,f,obj) {
	if (!(elt && elt.className))
		return;
	var className = elt.className;

	// HTML4.01 white space
	//  * ASCII space (&#x0020;)
	//  * ASCII tab (&#x0009;)
	//  * ASCII form feed (&#x000C;)
	//  * Zero-width space (&#x200B;)
//  1.0k2: Safari requires \s for spaces
//	var classNamesSplit = className.split(/[\u0020\u0009\u000C\u200B]+/);
	var classNamesSplit = className.split(/\s+/);
	for (j = 0; j < classNamesSplit.length; j++) {
		for (k = 0; k < classNames.length; k++) {
// 1.0h
//			if (classNamesSplit[j] == classNames[k]) {
			if (classNames[k] == '*' || classNamesSplit[j] == classNames[k]) {
//				f.call(this,all[i],classNames[k]);
//				f.call(this,elt,classNamesSplit[j],j,classNames[k],k); // (elt,className,classNameIndex,classNameArg,classNameArgIndex)
				f.call(obj,elt,classNamesSplit[j],j,classNames[k],k); // (elt,className,classNameIndex,classNameArg,classNameArgIndex)
//				this._log('parseClass(): class found:'+classNames[k],0);
			}
		}
	}
}
//-fxref-// _fss.parseClass:

//_fss.prototype.searchClass = function (classNames,f,tagName,top) {
_fss.searchClass = function (classNames,f,tagName,top) {
	if (!top) var top = document;
	if (!tagName) var tagName = '*';
//	this._log('searchClass(): top:'+top+', tagName:'+tagName,0);
	var all = top.getElementsByTagName(tagName);
//	this._log('searchClass(): all.length:'+all.length,0);
	for (var i = 0; i < all.length; i++) {
//		all[i].className && this.parseClass(all[i],classNames,f);
//		all[i].className && _fss.parseClass(all[i],classNames,f);
		all[i].className && _fss.parseClass(all[i],classNames,f,this);
//		if (all[i].className) {
//
//			// HTML4.01 white space
//			//  * ASCII space (&#x0020;)
//			//  * ASCII tab (&#x0009;)
//			//  * ASCII form feed (&#x000C;)
//			//  * Zero-width space (&#x200B;)
//			var classNamesSplit = all[i].className.split(/[\u0020\u0009\u000C\u200B]+/);
//			for (j = 0; j < classNamesSplit.length; j++) {
//				for (k = 0; k < classNames.length; k++) {
//// 1.0h
////					if (classNamesSplit[j] == classNames[k]) {
//					if (classNames[k] == '*' || classNamesSplit[j] == classNames[k]) {
////						f.call(this,all[i],classNames[k]);
//						f.call(this,all[i],classNamesSplit[j],j,classNames[k],k); // (elt,className,classNameIndex,classNameArg,classNameArgIndex)
//
//						this._log('searchClass(): class found:'+classNames[k],0);
//					}
//				}
//			}
//		}
	}
}
//-fxref-// _fss.searchClass: _fss.parseClass


////////////////////////////////////////////////////////////////
// changeClass
////////////////////////////////////////////////////////////////

//_fss.prototype.changeClass = function (from,to,tagName,top) {
_fss.changeClass = function (from,to,tagName,top) {
	var changeObject = new Object;
	var toArray = (to instanceof Array)? to: [to];
//	this.searchClass((from instanceof Array)? from: [from],
	_fss.searchClass((from instanceof Array)? from: [from],
		function(elt,className,classNameIndex,classNameArg,classNameArgIndex) {
			if (!(className in changeObject)) {
				changeObject[className] = new Object;
				changeObject[className].elts = new Array;
				changeObject[className].to = toArray[classNameArgIndex];
			}
			changeObject[className].elts.push(elt);
			
		},tagName,top);
	for (var className in changeObject) {
		for (var i = 0; i < changeObject[className].elts.length; i++) {
			var elt = changeObject[className].elts[i];
			var toClassName = changeObject[className].to? changeObject[className].to: '';
			var changedClassNameList = elt.className.replace(new RegExp('\\b'+className+'\\b'),toClassName);
			elt.className = changedClassNameList;
		}
	}
};
//-fxref-// _fss.changeClass: _fss.searchClass

////////////////////////////////////////////////////////////////


_fss.patchClass = function (elt,from,to) {
	if (!('className' in elt && elt.className)) return;
	var fromArray = (from instanceof Array)? from: [from];
	if (!fromArray.length) return;
	var reStr = '^(.*\\s)?('+fromArray[0];
	for (var i = 1; i < fromArray.length; i++)
		reStr += '|'+fromArray[i];
	reStr += ')(\\s.*)?$';
	var classNameListPatched = elt.className.replace(new RegExp(reStr),"$1"+to+"$3");
	if (classNameListPatched != elt.className)
		elt.className = classNameListPatched;
};
//-fxref-// _fss.patchClass:
