/*
    momo (Mouse Over Move Out)
    version 1.0 Copyright (C) 2007 Tagata Akira

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
    02110-1301 USA

*/

_fss.momo = function (elt,opt) {

	if (typeof elt == 'string') {
		var tagName = 'div';
		this.elt = _fss.elementIdentified(elt,tagName);
	}
	else  {
		this.elt = elt;
	}

	this.opt = opt? _fss.mergeObject(opt,this.optDefault): this.optDefault;

//-fxref-// _fss.momo: _fss.elementIdentified _fss.mergeObject

if (0) {
	function dump(o) {
		var str = '';
		for (var p in o) {
			str += p+':';
			if (typeof o[p] == 'object') {
				str += dump(o[p])+'\n';
			}
			else {
				str += o[p]+'\n';
			}
//			alert('p:'+p+', dump:'+str);
		}
		return str;
	}
	alert(dump(this.opt));
}

//
// +---------------------+
// |(element-A)          |  ================================================
// |                     |   for elt-X  event      target     relatedTarget 
// |  +----------------+ |  ================================================
// |  |(element-B)     | |   element-C  mouseover  element-C  element-B	 
// |  |                | |  ------------------------------------------------
// |  |  +-----------+ | |   element-B  mouseout   element-B  element-C	 
// |  |  |(element-C)| | |              mouseover  element-C  element-B	 
// |  |  |           | | |  ------------------------------------------------
// |  | ===>         | | |   element-A  mouseout   element-B  element-C	 
// |  |  |           | | |              mouseover  element-C  element-B	 
// |  |  +-----------+ | |  ------------------------------------------------
// |  +----------------+ |
// +---------------------+
//

//	function inElement(x,y,elt) {
//		var exy = _fss.elementXY(elt);
//		return exy.x <= x && x <= exy.x + elt.offsetWidth &&
//			exy.y <= y && y <= exy.y + elt.offsetHeight;
//	}

	function ignoreEvent(event,elt,over) {
		if (event.relatedTarget) {
			if (_fss.searchInside(event.relatedTarget,elt))
				return true;
		}
		else {
//			var inside = inElement(event.mouseX,event.mouseY,elt);
//			return over? !inside: inside;

//			if (event.target != elt)
//				return true;
		}
		return false;
	}

//-fxref-// _fss.momo: _fss.searchInside

	this.elt.$_momoo = this;
	this.fu = _fss.createUnit();
//	this.fu.ignoreTextNodeEvent = false;

//-fxref-// _fss.momo: _fss.createUnit

	function keepStayingDetected() {

		this.$_momoo.fu.clearEventListener('mousemove');
		if (!this.$_momoo.opt.um.mouseKeepStaying(this,this.$_momoo.fuEvent)) return;
		if (this.$_momoo.opt.style.mouseKeepStaying)
			_fss.setStyleSheetData(this,this.$_momoo.opt.style.mouseKeepStaying);
//		this.$_momoo.fu.setEventListener(this,handlerMouseOut,'mouseout');
	}

//	this.fu.initTimeout(undefined,undefined,this.elt);
	this.fu.initTimeout();

	function handlerMouseOver(e) {
// debug
//		if (e.relatedTarget) {
//			po._log('over: this.nodeName:'+this.nodeName+', e.target.nodeName:'+e.target.nodeName+', e.relatedTarget.nodeName:'+e.relatedTarget.nodeName);
//		}
//		else {
//			po._log('over: this.nodeName:'+this.nodeName+', e.target.nodeName:'+e.target.nodeName+', e.relatedTarget:'+e.relatedTarget);
//		}
// debug
		this.$_momoo.fuEvent = e;
//		if (ignoreEvent(e,this)) return;
		if (ignoreEvent(e,this,true)) return;
		this.$_momoo.fu.clearEventListener('mousemove');
		this.$_momoo.fu.clearTimeout();
		// MouseOver
		if (!this.$_momoo.opt.um.mouseOver(this,this.$_momoo.fuEvent)) return;
		if (this.$_momoo.opt.style.mouseOver)
			_fss.setStyleSheetData(this,this.$_momoo.opt.style.mouseOver);
		this.$_momoo.fu.setTimeout(this.$_momoo.opt.msec.onDelayed,
			function () {
				this.$_momoo.fu.clearTimeout();
				// MouseOverDelayed
				if (!this.$_momoo.opt.um.mouseOverDelayed(this,this.$_momoo.fuEvent)) return;
				if (this.$_momoo.opt.style.mouseOverDelayed)
					_fss.setStyleSheetData(this,this.$_momoo.opt.style.mouseOverDelayed);
				this.$_momoo.fu.setTimeout(this.$_momoo.opt.msec.keepStaying,keepStayingDetected,this);

				this.$_momoo.fu.setEventListener(this,function(e) {
					this.$_momoo.fuEvent = e;
					this.$_momoo.fu.clearTimeout();
					this.$_momoo.fu.setTimeout(this.$_momoo.opt.msec.keepStaying,keepStayingDetected,this);
				},'mousemove');
			},this);
	}

//-fxref-// _fss.momo: _fss.setStyleSheetData

	function handlerMouseOut(e) {
// debug
//		if (e.relatedTarget) {
//			po._log('out: this.nodeName:'+this.nodeName+', e.target.nodeName:'+e.target.nodeName+', e.relatedTarget.nodeName:'+e.relatedTarget.nodeName);
//		}
//		else {
//			po._log('out: this.nodeName:'+this.nodeName+', e.target.nodeName:'+e.target.nodeName+', e.relatedTarget:'+e.relatedTarget);
//		}
// debug
		this.$_momoo.fuEvent = e;
//		if (ignoreEvent(e,this)) return;
		if (ignoreEvent(e,this,false)) return;
		this.$_momoo.fu.clearEventListener('mousemove');//?
		this.$_momoo.fu.clearTimeout();
		// MouseOut
		if (!this.$_momoo.opt.um.mouseOut(this,this.$_momoo.fuEvent)) return;
		if (this.$_momoo.opt.style.mouseOut)
			_fss.setStyleSheetData(this,this.$_momoo.opt.style.mouseOut);
		this.$_momoo.fu.setTimeout(this.$_momoo.opt.msec.offDelayed,
			function () {
				// MouseOutDelayed
				if (!this.$_momoo.opt.um.mouseOutDelayed(this,this.$_momoo.fuEvent)) return;
				if (this.$_momoo.opt.style.mouseOutDelayed)
					_fss.setStyleSheetData(this,this.$_momoo.opt.style.mouseOutDelayed);
			},this);
	}

	this.fu.setEventListener(this.elt,handlerMouseOver,'mouseover');
	this.fu.setEventListener(this.elt,handlerMouseOut,'mouseout');
};

_fss.momo.prototype.optDefault = {
	msec: { onDelayed: 500, offDelayed: 500, keepStaying: 1000 },
	um: {
		mouseKeepStaying:	function () { return true; },
		mouseOverDelayed:	function () { return true; },
		mouseOutDelayed:	function () { return true; },
		mouseOver:		function () { return true; },
		mouseOut:		function () { return true; }
	},
	style: {
		mouseKeepStaying:	null,
		mouseOverDelayed:	null,
		mouseOutDelayed:	null,
		mouseOver:		null,
		mouseOut:		null
	}
};
