/*

    ssu (Standard Start Up)
    version 1.0 Copyright (C) 2006-2007 Tagata Akira

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
    02110-1301 USA

*/

/****************************************************************
  Warning.  This program specifications including API may change
  because of beta version.
****************************************************************/

_ssu.prototype = new _fss('ssu','Standard Start Up','1.0beta','2007 Tagata Akira','http://www.tagata.org/software/');

function _ssu(f,opt) {
	this.opt = opt? _fss.mergeObject(opt,this.optDefault): this.optDefault;

	if (this.available = this.avail()) {

		if (this.opt.prologue) this.opt.prologue();

		if (this.opt.info.mark.id
			&& this.opt.info.mark.classNameInit
			&& this.opt.info.mark.className) {

			var selector = '#'+ this.opt.info.mark.id + '.' + this.opt.info.mark.classNameInit;
			var info = _fss.getElementsBySelector(selector);
			if (info && info[0]) {
				_fss.patchClass(info[0],[this.opt.info.mark.classNameInit],this.opt.info.mark.className);
			}
		}

		var itxt = document.getElementById(this.opt.info.text.id);
		if (itxt && this.opt.info.text.style)
			_fss.setStyleSheetData(itxt,this.opt.info.text.style);

		_ssu.myobj = this;
		if (this.opt.bePatient.message) {
			this.obp = new _fss.bePatient(this.opt.bePatient.message,this.opt.bePatient.styleBody,this.opt.bePatient.styleSilhouette);
			this.obp.execute(function () {
				_ssu.myobj.setHandlers();

				_ssu.myobj.oInfo = new _setinfo({ id: _ssu.myobj.opt.info.mark.id },
					{ id: _ssu.myobj.opt.info.text.id },
					_ssu.myobj.opt.setinfo.waitIn,
					_ssu.myobj.opt.setinfo.timeIn,
					_ssu.myobj.opt.setinfo.waitOut,
					_ssu.myobj.opt.setinfo.timeOut,
					_ssu.myobj.opt.setinfo.delayOn,
					_ssu.myobj.opt.setinfo.delayOff);
				_ssu.cancelPredefined = function () { this.oInfo.fio.cancel(); };
				f.call(_ssu.myobj);
			},this);
		}
		else {
			this.setHandlers();
			this.oInfo = new _setinfo({ id: this.opt.info.mark.id },
					{ id: this.opt.info.text.id },
					this.opt.setinfo.waitIn,
					this.opt.setinfo.timeIn,
					this.opt.setinfo.waitOut,
					this.opt.setinfo.timeOut,
					this.opt.setinfo.delayOn,
					this.opt.setinfo.delayOff);
			_ssu.cancelPredefined = function () { this.oInfo.fio.cancel(); };
			f.call(this);
		}

		if (this.opt.epilogue) this.opt.epilogue();
	}

}
//-fxref-// _ssu: _fss.mergeObject _fss.getElementsBySelector
//-fxref-// _ssu: _fss.patchClass _fss.setStyleSheetData _fss.bePatient _setinfo

_ssu.prototype.outOfService = false;
_ssu.prototype.welcomeAll = false;

_ssu.prototype.optDefault = {
	bePatient: {
		message: null,
		styleBody:	{
			width:			'16em',
			textAlign:		'center',
			padding:		'1em',
			border:			'1px solid #c00',
			backgroundColor:	'#fcc',
			color:			'#c00'
		},
		styleSilhouette:	_fss.styleSilhouette
	},
	info: {
		mark: {
			id:		'info-mark',
			classNameInit:	undefined,
			className:	undefined
		},
		text: {
			id:	'info-text',
			style:	{ display: 'none' }
		}
	},
	setinfo: {
		waitIn:	3000,
		timeIn:	2000,
		waitOut:	undefined,
		timeOut:	undefined,
		delayOn:	undefined,
		delayOff:	undefined
	},
	prologue: function () {},
	elilogue: function () {}
};

_ssu.prototype.avail = function () {
// avail() returns availability

	if (this.outOfService) return false;

	if (!this.welcomeAll) {
		if (!(document.getElementById && document.createElement &&
			document.createTextNode && document.getElementsByTagName)) {
			return false;
		}
	}

	return true;
}

_ssu.prototype.setHandlers = function () {
	_ssu.cancelPredefined = function () {}; // dummy
	_ssu.innerSize = _fss.innerSize();
	window.onresize = function () {
		_ssu.cancelPredefined.call(_ssu.myobj);
		_ssu.innerSize = _fss.innerSize();
	};
	_ssu.scrollSize = _fss.scrollSize();
	window.onscroll = function () {
		_ssu.cancelPredefined.call(_ssu.myobj);
		_ssu.scrollSize = _fss.scrollSize();
	};
	document.onclick = function () {
		_ssu.cancelPredefined.call(_ssu.myobj);
	};

	_ssu.prototype._fssInsertUrl();
}
//-fxref-// _ssu: _fss.innerSize _fss.scrollSize
