/*

    CeLIST browser version 1.0, Copyright (C) 2006 Tagata Akira

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
    02110-1301 USA

*/

clsb.prototype = new _fss('clsb','CeLIST browser','1.0a','2006,2007 Tagata Akira','http://www.tagata.org/software/');


var CeLIST = {
	title:		'CeLIST',
	copyright:	'Ouchi Tatsuro',
	note:		'You may browse/edit CeLIST freely, or pass CeLIST to anyone who want to see.'
};

// RE to get version and copyright year from the first part of CeLIST
var reCeLIST = /\s*About\s+CeLIST\s+ver\.(\S+)\s+\(\S+\s+([0-9]+)/;


function clsb() {

	this.title = this._fssDesc();
	this.version = this._fssVer();
	this.copyright = this._fssCopy();

	var version = document.createElement('span');
	version.appendChild(document.createTextNode(' version '+this.version));
	version.style.fontSize = 'smaller';
	version.style.fontWeight = 'normal';

//	var title = this.elementIdentified('title','div')
	var title = _fss.elementIdentified('title','div')
	title.appendChild(document.createTextNode(this.title));
	title.appendChild(version);

//	var ba = this.elementIdentified('browsing-area','div');
	var ba = _fss.elementIdentified('browsing-area','div');
	this.browsingElt = ba;
//	var cm = this.elementIdentified('copyright-message','div');
	var cm = _fss.elementIdentified('copyright-message','div');

	document.body.appendChild(title);
	document.body.appendChild(ba);
	document.body.appendChild(cm);

	clsb.prototype._fssInsertUrl();
}
//-fxref-// clsb: _fss.elementIdentified

var funcColor = '#009900';
var funcSelectColor = '#990000';

var puInitColor = 'black';
var puInitBgColor = 'transparent';

var cuMargin = '2px 0.3em';
var cuPadding = '2px 0.7em';
//var cuBorder = '1px dotted #cccccc';
var cuBorder = '1px solid #eeeeee';

var puMouseoverColor = funcColor;
var puMouseoverBgColor = '#eeeeee';
var puSelectColor = funcSelectColor;
//var puSelectBgColor = '#ffffdd';
var puSelectBgColor = 'transparent';


// ----------------------------------------------------------------
function element(tagName,attrs) {
	var contents = '';
	if (2 < arguments.length) {
		for (var i = 2; i < arguments.length; i++) {
			contents += arguments[i];
		}
	}
	var attrList = '';
	if (attrs) {
		for (var attrName in attrs) {
			attrList += ' ' + attrName + '=' + attrs[attrName];
		}
	}
	var ret = '<' + tagName + attrList + '>';
	if (contents) {
		ret += contents + '</' + tagName + '>';
	}
	return ret;
}
// ----------------------------------------------------------------
function copyrightMessage() {

	var gplId = 'a-gpl';

	var versionCeLIST = CeLISTBrowser.versionCeLIST;
	var copyYearCeLIST = CeLISTBrowser.copyYearCeLIST;



	var title = CeLISTBrowser.title;
	var version = CeLISTBrowser.version;
	var copyright = '&copy; '+CeLISTBrowser.copyright;

	var message1 =
		element('div',{style: 'font-weight:bolder;'},
			title+' version '+version+', Copyright '+copyright);
	var message2 =
		element('div',{style: 'font-size:smaller;'},
			title+' comes with ABSOLUTELY NO WARRANTY.  This program is free software, and you are welcome to redistribute it under '
			+ element('a', {id: gplId, href: 'gpl.txt', target: '_blank'},
			'the GNU General Public License'));

	// CeLIST
	var messageCeLIST =
		element('span',{style: 'font-weight:bolder;'},
			CeLIST.title+' version '+versionCeLIST+', Copyright '+'&copy; '+copyYearCeLIST+' '+CeLIST.copyright+' ')/*+element('br',{style: 'font-size:smaller'})*/+element('span',{style: 'font-size:smaller'},CeLIST.note);

//    alert(messageCeLIST); // debug debug debug debug debug

	this.messageElement = document.getElementById('copyright-message');
//	this.messageElement.style.display = 'none';
	this.messageElement.style.display = 'block';
	this.messageElement.innerHTML = '';
	this.messageElement.innerHTML = message1 + message2 + messageCeLIST;

	this.messageGplElement = document.getElementById(gplId);


	this.messageElement.style.position = 'absolute';
//	var copyrightWidth = Math.floor((xmax - xmin) * 0.6);
	var copyrightWidth = Math.floor((xmax - xmin) * 0.75);
	this.messageElement.style.width = copyrightWidth + 'px';
	this.x = xmin + Math.floor(((xmax - xmin) - copyrightWidth)/2);
	this.y = ymin + Math.floor((ymax - ymin) / 2) + 40;
	this.messageElement.style.top = this.y + 'px';
	this.messageElement.style.left = this.x + 'px';

	this.moveCopyright = moveCopyright;
}
// ----------------------------------------------------------------
function moveCopyright() {
	var shadeColor = '#666';
	this.x = xmin;
//	this.y = ymax + 5;
	this.y = ymax + 10;
	this.messageElement.style.fontSize = 'smaller';
	this.messageElement.style.width = 'auto';
	this.messageElement.style.left = this.x + 'px';
	this.messageElement.style.top  = this.y + 'px';
	this.messageElement.style.color = shadeColor;
	this.messageGplElement.style.color = shadeColor;
}
// ----------------------------------------------------------------
function w3cdom() {
	return document.getElementById
		&& document.createElement
		&& document.createTextNode;
}
// ----------------------------------------------------------------
function displayPreface(offset) {
//alert('prefaceIndex:'+prefaceIndex+', offset:'+offset)
	if (0 < offset) {
		if (prefaceIndex + offset < oCeLIST.preface.length) {
			prefaceIndex += offset;
		}
	}
	else if (offset < 0) {
		if (0 <= prefaceIndex + offset) {
			prefaceIndex += offset;
		}
	}
	rewriteTextNode(oCeLIST.prefaceElement,oCeLIST.preface[prefaceIndex]);
	displayElm.appendChild(oCeLIST.prefaceElement);
}
// ----------------------------------------------------------------
function prefaceNext() { displayPreface(1); }
// ----------------------------------------------------------------
function prefacePrev() { displayPreface(-1); }
// ----------------------------------------------------------------
function displayList(offset) {
	if (0 < offset) {
		if (listIndex + offset < oCeLIST.list.length) {
			listIndex += offset;
		}
	}
	else if (offset < 0) {
		if (0 <= listIndex + offset) {
			listIndex += offset;
		}
	}

	if (!oCeLIST.displayElement) {
		oCeLIST.displayElement = new Array();
	}
	if (!oCeLIST.displayElement[listIndex]) {
		oCeLIST.displayElement[listIndex] = document.createElement('div');

		oCeLIST.displayElement[listIndex].style.overflow = 'auto';
		oCeLIST.displayElement[listIndex].style.height = displayElmHeight;
	}

	rewriteTextNode(oCeLIST.displayElement[listIndex],oCeLIST.list[listIndex]);
	removeDisplay();
	displayElm.appendChild(oCeLIST.displayElement[listIndex]);
}
// ----------------------------------------------------------------
function browsingNext() { displayList(1); }
// ----------------------------------------------------------------
function browsingPrev() { displayList(-1); }
// ----------------------------------------------------------------
function browsingNext10() { displayList(10); }
// ----------------------------------------------------------------
function browsingPrev10() { displayList(-10); }
// ----------------------------------------------------------------
function browsingHead() { displayList(listIndex = 0); }
// ----------------------------------------------------------------
function browsingTail() { displayList(listIndex = oCeLIST.list.length - 1); }
// ----------------------------------------------------------------
var guideLatest = 'check version';
var guidePreface = 'Preface';
var guideCeLIST  = 'CeLIST';
var guideReorg = 'Reorg';

var guideReorgComposers = 'Composers';
var guideReorgDates     = 'Dates';
var guideReorgPerformers   = 'Performers';
var guideReorgMedia     = 'Media';

var guideIndex = 'Index';
var guideHead  = 'Head';
var guideTail  = 'Tail';
var guidePrev  = 'Prev';
var guideNext  = 'Next';
var guideMorePrev  = 'Prev 10';
var guideMoreNext  = 'Next 10';

//var guideDebug = 'debug';

// ----------------------------------------------------------------
function menuItem(guide,thisGuide,onclick) {
	var item = appendButton(menuElm,thisGuide);
	if (guide == thisGuide) {
		item.style.color = funcSelectColor;
	}
	else {
		item.onclick = onclick;
		item.style.color = funcColor;
	}
	return item;
}
// ----------------------------------------------------------------
var bannerContainer;
// ----------------------------------------------------------------
function checkLatest() {

	if (bannerContainer == undefined) {
		bannerContainer = document.createElement('div');


		//  banner
		//    728x90 big
		//    468x60
		//    234x60 half

		bannerTop = 70;
		bannerLeft = 100;
		bannerWidth = 468;
		bannerHeight = 60;

		var colorMost = '#cfc';
		var colorMore = '#9c9';
		var colorLess = '#363';
		var colorLeast = '#030';

		_fss.setStyleSheetData(bannerContainer,{
			position: 'absolute',
			top: bannerTop + 'px',
			left: bannerLeft + 'px',
			backgroundColor: colorMore,
			padding: '1px',
			borderWidth: '1px',
			borderStyle: 'solid',
			borderColor: colorMost+' '+colorLess+' '+colorLess+' '+colorMost // outset simulation
		});

		bannerContainer.style.display = 'none';
		document.body.appendChild(bannerContainer);

		var title = document.createElement('div');
		_fss.setStyleSheetData(title,{
			textAlign: 'center'
		});
		title.appendChild(document.createTextNode('The latest CeLIST version information'));

		var close = document.createElement('div');
		_fss.setStyleSheetData(close,{
			position: 'absolute',
			top: '1px',
			right: '1px',
			cursor: 'default',
			fontSize: '0.8em',
			backgroundColor: colorLess,
			border: '1px solid '+colorMost,
			color: colorMost
		});
		close.appendChild(document.createTextNode('X'));
		close.title = 'close';
//		close.$b = this; // ???
//		close.onclick = function() { this.$b.onclick();	};
		close.onclick = function() { checkLatest(); };

		title.appendChild(close);

		var ifrContainer = document.createElement('div');
		_fss.setStyleSheetData(ifrContainer,{
			borderWidth: '1px',
			borderStyle: 'solid',
			borderColor: colorLess+' '+colorMost+' '+colorMost+' '+colorLess // inset simulation
		});
		// IE6 requires innerHTML here to effect these attributes
		ifrContainer.innerHTML = '<iframe src="'+latestInfoUrl+'" frameborder="0" marginwidth="0" marginheight="0" width="'+bannerWidth+'" height="'+bannerHeight+'"></iframe>';

		bannerContainer.appendChild(title);
		bannerContainer.appendChild(ifrContainer);
	}

	if (bannerContainer.$f ^= 1) {
		bannerContainer.style.display = 'block';
	}
	else {
		bannerContainer.style.display = 'none';
	}
}
//-fxref-// clsb: _fss.setStyleSheetData
// ----------------------------------------------------------------
function menu(guide) {

	// remove all menu item
	var y = menuElm;
	while (y.firstChild) y.removeChild(y.firstChild);

	var preface = menuItem(guide,guidePreface,oCeLIST.browsingPreface);
	var celist  = menuItem(guide,guideCeLIST,browsingCeLIST);

	var reorg = menuItem(guide,guideReorg,browsingReorg);
	reorg.style.marginLeft = '0.5em';

	if (typeof latestInfoUrl != 'undefined' && latestInfoUrl) {
		var latest = menuItem(guide,guideLatest,checkLatest);
		latest.style.marginLeft = '1em';
		latest.style.fontSize = 'x-small';
	}
}
// ----------------------------------------------------------------
function mouseoverPu() {
	this.style.color = puMouseoverColor;
	this.style.textDecoration = 'underline';
	this.style.backgroundColor = puMouseoverBgColor;
}
// ----------------------------------------------------------------
function mouseoutPu() {
	this.style.color = this.$u.c;
	this.style.textDecoration = 'none';
	this.style.backgroundColor = this.$u.b;
}
// ----------------------------------------------------------------
function setPu(x) {
	x.onmouseover = mouseoverPu;
	x.onmouseout  = mouseoutPu;
	x.onclick = clickPu;
	x.style.cursor = 'pointer';
//	x.style.textDecoration = 'underline';
	x.$u.c = puInitColor;
	x.$u.b = puInitBgColor;
}
// ----------------------------------------------------------------
function genElms(thisElm) {
	thisElm.$u.g = 1; // generated
	var value = genv.value;
	var property = genv.order[thisElm.$u.o];

	var cu = document.createElement('div'); // children unit
	cu.style.margin = cuMargin;
	cu.style.padding = cuPadding;
	cu.style.display = 'block';
	cu.style.border = cuBorder;
	if (thisElm.nextSibling)
		thisElm.parentNode.insertBefore(cu,thisElm.nextSibling);
	else
		thisElm.parentNode.appendChild(cu);

	for (var i = 0; i < thisElm.$u.u.length; i++) {
		var top = thisElm.$u.u[i].t;
		var title = value[property][top];
		if (thisElm.$u.u[i].n) {
			title += ' ['+thisElm.$u.u[i].n+']';
		}
		var pu = document.createElement('div'); // parent unit
		pu.appendChild(document.createTextNode(title));
		cu.appendChild(pu);
		if (thisElm.$u.u[i].u && thisElm.$u.u[i].u.length) {
			pu.$u = thisElm.$u.u[i];
			setPu(pu);
		}
	}
}
// ----------------------------------------------------------------
function clickPu() {
	this.$ff = function () {
		if (this.$u.h ^= 1) {
			this.style.color = this.$u.c = puInitColor;
			this.style.backgroundColor = this.$u.b = puInitBgColor;
	//		this.style.textDecoration = 'underline';
			this.nextSibling.style.display = 'none';
		}
		else {
			this.style.color = this.$u.c = puSelectColor;
			this.style.backgroundColor = this.$u.b = puSelectBgColor;
	//		this.style.textDecoration = 'none';
			this.nextSibling.style.display = 'block';
		}
	};


	if (this.$u && !this.$u.g) {
		var msg = _fss.concatenateTextNode(this);
		this.$iwo = new waitingTag(msg+' waiting...',
			function() {
				genElms(this);
				this.$ff();
			},this);
	}
	else {
		this.$ff();
	}
}
//-fxref-// clsb: _fss.concatenateTextNode
// ----------------------------------------------------------------
function clComp(a,b) {
//	var ret = 0;
	for (var i = 0; i < compOrder.length; i++) {
		var prop = compOrder[i];
		var idxA = a[prop]; // idx a
		var idxB = b[prop]; // idx b
		if (idxA != idxB) {
			var valueA = compValue[prop][idxA];
			var valueB = compValue[prop][idxB];
			if (valueA < valueB) {
//				ret = -1;
//				break;
				return -1;
			}
			else if (valueA > valueB) {
//				ret = 1;
//				break;
				return 1;
			}
		}
	}
//	return ret;
	return 0;
}
// ----------------------------------------------------------------
function genUnit(hide,iIndex,iLength,oIndex) {

	var order = genv.order;
	var cl = genv.cl;
	var value = genv.value;

	this.n = 0;

	if (oIndex + 1 < order.length ||
		oIndex < order.length && cl[iIndex][order[oIndex]]) {
		var property = order[oIndex];

//		this.c = puInitColor;
//		this.b = puInitBgColor;

		this.h = hide;
		this.o = oIndex; // save to set title
		this.u = new Array();

		var topIndex = iIndex;
		var top = cl[topIndex][property];
		var i;
		for (i = topIndex + 1; i < iLength; i++) {
			var curr = cl[i][property];

			if (!curr) continue; // bypass error

			if (top != curr && value[property][top] != value[property][curr]) {
				var j = this.u.length;
				this.u[j] = new genUnit(1,topIndex,i,oIndex+1);
				this.u[j].t = top; // save to set title

				this.n++;
				topIndex = i;
				top = cl[topIndex][property];
			}
		}
		var j = this.u.length;
		this.u[j] = new genUnit(1,topIndex,i,oIndex+1);
		this.u[j].t = top; // save to set title

		this.n++;
	}
}
// ----------------------------------------------------------------
function reorganizedAny(guideAny,reorgElm) {
    this.st = new stat();
    reorgMenu(guideAny);

    if (!reorgElm) {

	reorgElm = document.createElement('div');

	this.reorgAnyO = new waitingTag(guideAny+' proceeding...',
function () {

	var title = guideAny;

	var pu = document.createElement('div');


	this.st.noSec();
	this.st.rewrite(title+' sorting...');

	// sort
	compOrder = genv.order;
	compValue = this.value;
	this.idx.cl.sort(clComp);

	this.st.appendSec();
	this.st.append('done');
	this.st.rewrite();
	this.st.noSec();
	this.st.append('.  ');

	this.st.resetMsec();
	this.st.append('Converting...');
	this.st.rewrite();

//	var x = new genUnit(0, 0, genv.cl.length, 0);
	pu.$u = new genUnit(1, 0, genv.cl.length, 0);
	setPu(pu);
	if (pu.$u.n) {
	    title += ' ['+pu.$u.n+']';
	}

	this.st.appendSec();
	this.st.append('done');
	this.st.rewrite();
	this.st.noSec();
	this.st.append('.  ');

	this.st.resetMsec();
	this.st.append('Rendering...');
	this.st.rewrite();

	pu.appendChild(document.createTextNode(title));
//	pu.$p = reorgElm;

	reorgElm.style.overflow = 'auto';
	reorgElm.style.height = displayElmHeight;

//	genElms(pu);

	reorgElm.appendChild(pu);

	displayElm.appendChild(reorgElm);

	this.st.appendSec();
	this.st.append('done');
	this.st.rewrite();
	this.st.noSec();
	this.st.append('.');
	this.st.rewrite();
},this);
    }
    else {
	displayElm.appendChild(reorgElm);
	reorgElm.style.overflow = 'auto';
	reorgElm.style.height = displayElmHeight;

	this.st.rewrite(guideAny+' browsing...');
    }

    return reorgElm;
}
// ----------------------------------------------------------------
function reorganizedComposers() {
    genv.order = ['composer','work','date','performer','medium'];
    oReorganizedCeLIST.composersElement =
	oReorganizedCeLIST.reorganizedAny(guideReorgComposers,oReorganizedCeLIST.composersElement);
}
// ----------------------------------------------------------------
function reorganizedDates() {
    genv.order = ['date','composer','work','performer','medium'];
    oReorganizedCeLIST.datesElement =
	oReorganizedCeLIST.reorganizedAny(guideReorgDates,oReorganizedCeLIST.datesElement);
}
// ----------------------------------------------------------------
function reorganizedPerformers() {
    genv.order = ['performer','composer','work','date','medium'];
    oReorganizedCeLIST.performersElement =
	oReorganizedCeLIST.reorganizedAny(guideReorgPerformers,oReorganizedCeLIST.performersElement);
}
// ----------------------------------------------------------------
function reorganizedMedia() {
    genv.order = ['medium','composer','work','date','performer'];
    oReorganizedCeLIST.mediaElement =
	oReorganizedCeLIST.reorganizedAny(guideReorgMedia,oReorganizedCeLIST.mediaElement);
}
// ----------------------------------------------------------------
function pushValProp(prop,value) {
	var idx = this[prop].length;
	this[prop][idx] = value;
	return idx;
}
// ----------------------------------------------------------------
function catValProp(prop,value) {
	var idx = this[prop].length - 1;
	// length > 1, because valArray() is called
	this[prop][idx] += value;
	return idx;
}
// ----------------------------------------------------------------
function clArray(init) {
//function clArray() {
	this.cl = new Array();
	this.cl.$length = 0;
	this.init = init;
	this.initElm = initElm;
	this.pushProp = pushIdxProp;
}
// ----------------------------------------------------------------
function initElm() {
	var idx = this.cl.length;
	var init = this.init;
	this.cl[idx] = {
		composer:	init,
		work:		init,
		date:		init,
		performer:	init,
		medium:		init
	};
	return idx;
}
// ----------------------------------------------------------------
function pushIdxProp(prop,value) {
	if (this.cl.length == 0) {
		this.initElm();
	}

	var idx = this.cl.length - 1;
//	if (this.cl[idx] && this.cl[idx][prop] == this.init) {
	if (this.cl[idx][prop] == this.init) {
		this.cl[idx][prop] = value;
		if (document.$ini.maintenance) { // ** maintenance mode **
			for (p in this.cl[idx-1]) {
				if (this.cl[idx-1][p] == this.init && p != 'medium') {
					document.$ini.maintenance.$lput('Error: '+p+'['+(idx-1)+']'); //  ** pending **
				}
			}
		}
	}
	else { // already exists
		idx = this.initElm(); // get next one
		for (p in this.cl[idx-1]) { // for all properties of previous
			if (p != prop) { // copy until prop
				this.cl[idx][p] = this.cl[idx-1][p]; // copy
			}
			else { // set prop and value and return
				this.cl[idx][p] = value;
				break;
			}
		}
	}
	return idx;
}
// ----------------------------------------------------------------
function valArray(init) {
    this.init = init;
    this.composer    = new Array();
    this.composer[0] = init;
    this.work        = new Array();
    this.work[0]     = init;
    this.date        = new Array();
    this.date[0]     = init;
    this.performer      = new Array();
    this.performer[0]   = init;
    this.medium      = new Array();
    this.medium[0]   = init;
    this.pushProp = pushValProp;
    this.catProp = catValProp;
}
// ----------------------------------------------------------------
var ReOrgError = '_ReOrganization_error_';
function buildReorganizedCeLIST(list) {
	// CeLIST reorg
	var st = new stat();

	this.value = new valArray(ReOrgError);
	this.idx = new clArray(0);	// 0 means ReOrgError

//alert(this.idx.cl.length);

	this.reorganizeCeLIST = reorganizeCeLIST;
//alert('|'+list[0]+'|');
	for (var i = 0; i < list.length; i++) {
		this.reorganizeCeLIST(list[i],i);
		st.rewrite('Reorganizing '+oCeLIST.item[i]+'...');
	}

	if (document.$ini.maintenance) { // ** maintenance mode **
		document.$ini.maintenance.$lput('reorganized count, '+
			'composer:['+this.value.composer.length+']'+
			', work:['+this.value.work.length+']'+
			', date:['+this.value.date.length+']'+
			', performer:['+this.value.performer.length+']'+
			', medium:['+this.value.medium.length+']'+
			' / comp list:['+this.idx.cl.length+']');
	}

	genv.cl = this.idx.cl;
	genv.value = this.value;

	this.reorganizedAny = reorganizedAny;
}
// ----------------------------------------------------------------
function reorgMenu(guide) {
    removeAllButtons(opElm);
    removeDisplay();

    var composers = appendButton(opElm,guideReorgComposers);
    composers.onclick = reorganizedComposers;
    if (guide == guideReorgComposers) {
	composers.style.color = funcSelectColor;
    }
    else {
	composers.style.color = funcColor;
    }

    var dates = appendButton(opElm,guideReorgDates);
    dates.onclick = reorganizedDates;
    if (guide == guideReorgDates) {
	dates.style.color = funcSelectColor;
    }
    else {
	dates.style.color = funcColor;
    }

    var performers = appendButton(opElm,guideReorgPerformers);
    performers.onclick = reorganizedPerformers;
    if (guide == guideReorgPerformers) {
	performers.style.color = funcSelectColor;
    }
    else {
	performers.style.color = funcColor;
    }

    var media = appendButton(opElm,guideReorgMedia);
    media.onclick = reorganizedMedia;
    if (guide == guideReorgMedia) {
	media.style.color = funcSelectColor;
    }
    else {
	media.style.color = funcColor;
    }
}
// ----------------------------------------------------------------
function browsingReorg() {
//    var st = new stat();

    if (!oReorganizedCeLIST) {
	reorgWo = new waitingTag('Reorganizing CeLIST...',
		function () {
			oReorganizedCeLIST = new buildReorganizedCeLIST(oCeLIST.list);

			removeAllButtons(opElm);
			removeDisplay();
			reorgMenu('');
			menu(guideReorg);
		},document);
    }
    else {
	removeAllButtons(opElm);
	removeDisplay();
	reorgMenu('');
	menu(guideReorg);
    }
}
// ----------------------------------------------------------------
function browsingCeLIST() {
    var st = new stat('CeLIST browsing...');

    removeAllButtons(opElm);
    removeDisplay();

    var index = appendButton(opElm,guideIndex);
    index.onclick = browsingIndex;
    index.style.marginRight = '0.5em';

    var head = appendButton(opElm,'head');
    head.onclick = browsingHead;

    var prev10 = appendButton(opElm,'prev 10');
    prev10.onclick = browsingPrev10;

    var prev = appendButton(opElm,'prev');
    prev.onclick = browsingPrev;
    prev.style.fontWeight = 'bolder';

    var next = appendButton(opElm,'next');
    next.onclick = browsingNext;
    next.style.marginLeft = '0.5em';
    next.style.fontWeight = 'bolder';

    var next10 = appendButton(opElm,'next 10');
    next10.onclick = browsingNext10;

    var tail = appendButton(opElm,'tail');
    tail.onclick = browsingTail;

    menu(guideCeLIST);

    displayList(0);
//    rewriteStatus('CeLIST browsing...');
    st.rewrite();
}
// ----------------------------------------------------------------
function browsingIndex() {
    var st = new stat('Index browsing...');
    removeAllButtons(opElm);
    removeDisplay();

    var celist = appendButton(opElm,guideCeLIST);
    celist.onclick = browsingCeLIST;

    oCeLIST.displayIndex();

//    rewriteStatus('Index browsing...');
    st.rewrite();
}
// ----------------------------------------------------------------
function removeAllButtons(x) {
    var y = x.getElementsByTagName('BUTTON');
    while (y.firstChild) y.removeChild(y.firstChild);
    while (x.firstChild) x.removeChild(x.firstChild);
}
// ----------------------------------------------------------------
function appendElement(x,elementTagName,text) {
    var y;
    y = document.createElement(elementTagName);
    y.appendChild(document.createTextNode(text));
    x.appendChild(y);
    return y;
}
// ----------------------------------------------------------------
function appendButton(x,guide) {
    return appendElement(x,'button',guide);
}
// ----------------------------------------------------------------
function browsingPreface() {
    var st = new stat('Preface...');

    if (!this.prefaceElement) {
	this.prefaceElement = document.createElement('div');

	this.prefaceElement.style.overflow = 'auto';
	this.prefaceElement.style.height = displayElmHeight;
    }

    removeAllButtons(opElm);
    removeDisplay();

    var prev = appendButton(opElm,'prev');
    prev.onclick = prefacePrev;
    prev.style.fontWeight = 'bolder';

    var next = appendButton(opElm,'next');
    next.onclick = prefaceNext;
    next.style.fontWeight = 'bolder';

    menu(guidePreface);

//    rewriteStatus('Preface...');

//    displayElm.lang="ja";
    displayPreface(prefaceIndex = 0);
    st.rewrite();
}
// ----------------------------------------------------------------
function mouseoverIndexElement() {
    this.style.color = funcColor;
    this.style.backgroundColor = '#cccccc';
}
// ----------------------------------------------------------------
function mouseoutIndexElement() {
    this.style.color = '#000000';
    this.style.backgroundColor = 'transparent';
}
// ----------------------------------------------------------------
function clickIndexElement() {
    this.style.color = '#000000';
    this.style.backgroundColor = 'transparent';
    listIndex = this.listIndex;
    browsingCeLIST();
}
// ----------------------------------------------------------------
function createIndexElement(element, index) {
    var ret = document.createElement('div');
    ret.appendChild(document.createTextNode(element));
    ret.listIndex = index;
    ret.onmouseover = mouseoverIndexElement;
    ret.onmouseout  = mouseoutIndexElement;
    ret.onclick = clickIndexElement;
    ret.style.cursor = 'pointer';
    return ret; // return div element contains index item
}
// ----------------------------------------------------------------
function displayIndex() {
    if (!this.indexElement) {
	this.indexElement = document.createElement('div');
	for (var i = 0; i < oCeLIST.composerElements.length; i++) {
	    this.indexElement.appendChild(oCeLIST.composerElements[i]);
	}
	this.indexElement.style.overflow = 'auto';
	this.indexElement.style.height = displayElmHeight;
    }
    displayElm.appendChild(this.indexElement);
}
// ----------------------------------------------------------------
function removeDisplay() {
    var y = displayElm;
    while (y.firstChild) y.removeChild(y.firstChild);
}
// ----------------------------------------------------------------
function buildIndex(item) {
    this.composerElements = new Array();
    for (var i = 0; i < item.length; i++) {
	this.composerElements[i] =
	    createIndexElement(item[i], i);
    }
    this.displayIndex = displayIndex;
}
// ----------------------------------------------------------------
function prCell(value) { // performance record cell object
    this.value = value;
//    this.o = new Array();
}
// ----------------------------------------------------------------
function setPrValue(pObj,value) {
// pObj: parent obj
//    if (pObj == null || pObj.o == 'undefined') return null;
    if (pObj == null) return null;
    if (!pObj.o) pObj.o = new Array();
//    return pObj.o[pObj.o.length] = new prCell(value);
    return pObj.o[pObj.o.length] = {value: value};
}
// ----------------------------------------------------------------
function setCrootPrValue(pObj,sObj,prValue) {
// sObj: object for save
    var length = sObj.length;
    sObj[length] = prValue;
    return setPrValue(pObj,length);
}
// ----------------------------------------------------------------
function reorganizeCeLIST(compserBlock, index) {
if (1) { ////////////////////////////////////////////////////////////////

	var reorganizeRe = /^( *)(\S[^\n\r]+)/gm;

	var lines = new Array();
	var prevIdent = -1; // init
	var ident;

	var match;
	while (match = reorganizeRe.exec(compserBlock)) {
		ident = match[1].length;
		if (prevIdent != ident) {
			lines.push({ ident: ident, str: match[2] });
			prevIdent = ident;
		}
		else {
			lines[lines.length-1].str += match[2]; // append
		}
	}

	var identStr;
	for (var i = 0; i < lines.length; i++) {
		if (lines[i].ident == 0 || lines[i].ident == 3 || lines[i].ident == 6) {
			identStr = (lines[i].ident == 0)? 'composer':
				(lines[i].ident == 3)? 'work':
				(lines[i].ident == 6)? 'date': undefined;
			this.idx.pushProp(identStr,this.value.pushProp(identStr,lines[i].str));
		}
		else if (lines[i].ident == 9 || lines[i].ident == 12) {
			if (lines[i].ident == 9)
				var identStr = 'performer';
			else if (lines[i].ident == 12)
				var identStr = 'medium';
			var re = /([^;]*);\s*/g;
			var strMatch;
			var lastIndex = 0;
			while (strMatch = re.exec(lines[i].str)) {
				this.idx.pushProp(identStr,this.value.pushProp(identStr,strMatch[1]));
				lastIndex = re.lastIndex;
			}
			if (lastIndex < lines[i].str.length) {
				this.idx.pushProp(identStr,this.value.pushProp(identStr,lines[i].str.substring(lastIndex)));
			}
		}
		else {
			if (document.$ini.maintenance) { // ** maintenance mode **
				document.$ini.maintenance.$lput('['+index+','+i+'] '+'indent error line:'+lines[i].str);
			}
		}
	}
} ////////////////////////////////////////////////////////////////
else { ////////////////////////////////////////////////////////////////
	var reorganizeRe = /^( *)(\S[^\n\r]+)/gm;

	var workFirst = true;
	var match;
	while (match = reorganizeRe.exec(compserBlock)) {
		if (match[1].length == 0) {
			workFirst = true; //
			this.idx.pushProp('composer',this.value.pushProp('composer',match[2]));
		}
		else if (match[1].length == 3) {
			if (workFirst) {
				this.idx.pushProp('work',this.value.pushProp('work',match[2]));
				workFirst = false;
			}
			else {
				this.value.catProp('work',match[2]);
			}
		}
		else if (match[1].length == 6) {
			workFirst = true; //
			var re = /^[0-9\?]/;
			if (re.exec(match[2])) {
				this.idx.pushProp('date',this.value.pushProp('date',match[2]));
			}
			else {
				this.value.catProp('date',match[2]);
			}
		}
		else if (match[1].length == 9) {
			workFirst = true; //
			var re = /([^;]*);\s*/g;
			var performersMatch;
			var lastIndex = 0;
			while (performersMatch = re.exec(match[2])) {
				this.idx.pushProp('performer',this.value.pushProp('performer',performersMatch[1]));
				lastIndex = re.lastIndex;
			}
			if (lastIndex < match[2].length) {
				this.idx.pushProp('performer',this.value.pushProp('performer',match[2].substring(lastIndex)));
			}
		}
		else if (match[1].length == 12) {
			workFirst = true; //
			var re = /^(CD|CD-R|CT|DAT|DVD|LD|LP|VT|\?)/;
			if (re.exec(match[2])) {
				this.idx.pushProp('medium',this.value.pushProp('medium',match[2]));
			}
			else {
				this.value.catProp('medium',match[2]);
			}
		}
		else {
			workFirst = true; //
			if (document.$ini.maintenance) { // ** maintenance mode **
				document.$ini.maintenance.$lput('['+index+'] '+'indent error:'+compserBlock);
			}
		}
	}
} ////////////////////////////////////////////////////////////////
}
// ----------------------------------------------------------------
function buildCeLIST() {

	buildingCeLIST = 1;

// ** \r may not be required here **
// ** old version comment when getting data via iframe **
// MSIE seems to change \n to \r
    var prefaceSeparator = /^\*[*+1-7]+\*+[\n\r]/gm;
    var bodySeparator = /^[\n\r]/gm;
    var terminator = /\*[*+EOF]+\*+/;

    var stringCeLIST;

    var xho = new _fss.XMLHttp;
    var nameCeLIST = document.fileCeLIST || 'CeLIST.txt';
    if (stringCeLIST = xho.getSyn(nameCeLIST)) {
    }
    else {
	alert(nameCeLIST+' not found!');
	this.fail = true;
	return;
    }



    var lastIndex = 0;
    this.preface = new Array();
    var match;

    while(match = prefaceSeparator.exec(stringCeLIST)) {
	var sepHead = prefaceSeparator.lastIndex - match[0].length;
	this.preface.push(stringCeLIST.substring(lastIndex, sepHead).replace(/^\s+/,''));
	lastIndex = prefaceSeparator.lastIndex;
    }


	if (this.preface.length) {
		if ((match = reCeLIST.exec(this.preface[0])) && match.length >= 2) {
			CeLISTBrowser.versionCeLIST = match[1];
			CeLISTBrowser.copyYearCeLIST = match[2];
		}
		else {
			CeLISTBrowser.versionCeLIST = '';
			CeLISTBrowser.copyYearCeLIST = '';
		}
	}


    // copyright
    // copyrightMessage() needs CeLISTBrowser.versionCeLIST
    showingCopyright = 1;
    oCopyright = new copyrightMessage();
    tid = window.setTimeout('clearCopyright()', 3000);


// the split behaviour of Safari differs from Mozilla, Opera, MSIE
//    this.list = stringCeLIST.substring(lastIndex).split(bodySeparator);
//    for (var i = 0; i < this.list.length; i++) {
//	this.list[i] = this.list[i].replace(/^\s+/,'');
//    }
    this.list = new Array();
    var bodyLastIndex = lastIndex;
    bodySeparator.lastIndex = bodyLastIndex;
    while(match = bodySeparator.exec(stringCeLIST)) {
	var sepHead = bodySeparator.lastIndex - match[0].length;
	this.list.push(stringCeLIST.substring(bodyLastIndex, sepHead).replace(/^\s+/,''));

	bodyLastIndex = bodySeparator.lastIndex;
    }
    this.list[this.list.length]
	= stringCeLIST.substring(bodyLastIndex).replace(/^\s+/,'');

    // remove last empty array element (opera?)
    if (this.list.length && !this.list[this.list.length - 1]) {
	this.list.pop();
    }

    // remove terminator
    if (this.list.length) {
	this.list[this.list.length - 1] =
	    this.list[this.list.length - 1].replace(terminator,'');
    }


    ////////////////////////////////////////////////////////////////
    // index
    this.itemRe = /^[^\s*][^\n\r]+/gm;
    this.item = new Array();
    this.itemRe.lastIndex = lastIndex;
    while(match = this.itemRe.exec(stringCeLIST)) {
	this.item[this.item.length] = match[0];
    }
    this.buildIndex = buildIndex;
    this.buildIndex(this.item);

    delete stringCeLIST; // free
}
//-fxref-// clsb: _fss.XMLHttp
// ----------------------------------------------------------------
function hideNode(node) {
    if (node.childNodes[0]) {
	node.removeChild(node.childNodes[0]);
    }
}
// ----------------------------------------------------------------
function rewriteTextNode(node,text) {
    if (text)
	node.innerHTML = '<pre>'+text+'\n</pre>';
}
// ----------------------------------------------------------------
function rewriteStatusNode(node,text) {
    var textInfo = document.createTextNode(text);
    if (node.childNodes[0]) {
	node.removeChild(node.childNodes[0]);
    }
    node.appendChild(textInfo);
}
// ----------------------------------------------------------------
function rewriteStatus(status) {
    rewriteStatusNode(statusElm,status);
}
// ----------------------------------------------------------------
// stat
// ----------------------------------------------------------------
function stat(msg) {
    function msec() {
	var now = new Date(); return now.getTime();
    }
    this.msecStart = msec();
    if (msg)
	this.msg = msg;
    else
	this.msg = '';
    // method
    this.noSec = function () { this.appendSecond = 0; };
    this.resetMsec = function () { this.msecStart = msec(); };
    this.appendSec = function () { this.appendSecond = 1; };
    this.rewrite = function (msg) {
	function secStr(msec) {
	    var sec = Math.floor(msec/1000);
	    var msecStr = '000' + msec%1000;
	    return sec + '.' + msecStr.substr(msecStr.length - 3) + 'sec';
	}
	if (msg) this.msg = msg;
	if (this.appendSecond)
		this.msg += ' ('+secStr(msec()-this.msecStart)+')';
	rewriteStatus(this.msg);
    }

    this.append = function (msg) { this.msg += msg; };
//    this.appendSec();
    this.appendSecond = 1;
}
// ----------------------------------------------------------------
function viewPort() {
    // following get width/height script from www.quirksmode.org
    var width;
    var height;

    if (self.innerHeight) // all except Explorer
    {
	width = self.innerWidth;
	height = self.innerHeight;
    }
    else if (document.documentElement && document.documentElement.clientHeight)
    // Explorer 6 Strict Mode
    {
	width = document.documentElement.clientWidth;
	height = document.documentElement.clientHeight;
    }
    else if (document.body) // other Explorers
    {
	width = document.body.clientWidth;
	height = document.body.clientHeight;
    }
    this.width =  width;
    this.height = height;
}
// ----------------------------------------------------------------
function main1() {
	if (!w3cdom()) return 1; // W3C DOM check

	CeLISTBrowser = new clsb();

	vp = new viewPort();

	var margin = 0.01; // ratio
	var xMarginLeft = Math.round(margin * vp.width);
	var xMarginRight = Math.round(margin * vp.width);
	var xPaddingLeft = 0;
	var xPaddingRight = 0;
	xmin = xMarginLeft + xPaddingLeft;
	xmax = vp.width - (xMarginRight + xPaddingRight) + 1;

	var yMarginTop = Math.round(margin * vp.height);
	var yMarginBottom = Math.round(margin * vp.height);
	var yPaddingTop = 0;
	var yPaddingBottom = 45;
	ymin = yMarginTop + yPaddingTop;
	ymax = vp.height - (yMarginBottom + yPaddingBottom);


	var browsingAreaElm = CeLISTBrowser.browsingElt;

	var st = new stat();

	// status area
	statusElm = document.createElement('div');
	statusElm.style.padding = '0.2em';
	statusElm.style.height = '1em';
	statusElm.style.backgroundColor = '#999';
	browsingAreaElm.appendChild(statusElm);

	st.noSec();
	st.rewrite('Started...');

	// op area
	opElm = document.createElement('div');
	opElm.style.margin = '0.5em 1em 0 1em';
	browsingAreaElm.appendChild(opElm);

	// menu area
//	menuElm = CeLISTBrowser.elementIdentified('main-menu','div');
	menuElm = _fss.elementIdentified('main-menu','div');
	browsingAreaElm.appendChild(menuElm);

//	displayElm = CeLISTBrowser.elementIdentified('display-area','div');
	displayElm = _fss.elementIdentified('display-area','div');
	browsingAreaElm.appendChild(displayElm);

	displayElmSetStyle();

	st.appendSec();
	st.rewrite('done');
	st.noSec();
	st.rewrite('.');
}
//-fxref-// clsb: _fss.elementIdentified
// ----------------------------------------------------------------
function displayElmSetStyle() {

	var displayTop = 90; // in px

	displayElm.style.position = 'absolute';
	displayElm.style.left = xmin + 'px';
	displayElm.style.padding = '5px';
	displayElm.style.border = '1px inset #fff';
	displayElm.style.width = (xmax - xmin - 12) + 'px'; // 12 = padding(10) + border(2)
	displayElm.style.top = displayTop + 'px';
	displayElmHeight = (ymax - ymin - displayTop) + 'px';
	displayElm.style.height = displayElmHeight;
}
// ----------------------------------------------------------------
function main2() {

	var st = new stat('Building...');
	st.noSec();
	st.rewrite();

	buildingCeLIST = 0; // finished


	listIndex = 0; // init

	rewriteStatus(oCeLIST.list.length+' lists collected');

	oCeLIST.browsingPreface = browsingPreface;

	st.appendSec();
	st.rewrite('done');
	st.noSec();
	st.rewrite('.');
}
// ----------------------------------------------------------------
function clearCopyright() {
	showingCopyright = 0;
	if (typeof oCopyright != 'undefined') {
		oCopyright.moveCopyright();
		if (!buildingCeLIST) {
			oCeLIST.browsingPreface();
		}
	}
}
// ----------------------------------------------------------------
function waitingTag(msg,f,obj) {
	this.bpo = new _fss.bePatient(msg,bpBody,bpSilhouette);
	this.bpo.execute(f,obj || this.bpo);
}
//-fxref-// clsb: _fss.bePatient
// ----------------------------------------------------------------
function startUp() {

	var infoSource = 'i\
<div id="info-text" class="">\
Operate buttons for menu and sub-menu appeared consequently upon your request.\
	<table>\
	<tr><th>menu</th><th>request</th></tr>\
	<tr><td>Preface</td><td>To show the preface parts of the original CeLIST</td></tr>\
	<tr><td>CeLIST</td><td>To show the each composer parts of the original CeLIST</td></tr>\
	<tr><td>Reorg</td><td>To reorganize CeLIST to view some sorted results.  The sort will be done hierachically and you will be able to see in depth to click the result lines.  <strong>You may encounter waiting for a while only the very first of your action.  Thank you for your patience.</strong></td></tr>\
	<tr><td>check version</td><td>To get the latest CeLIST version information asking the site of origin.</td></tr>\
	</table>\
</div>';

	var ssuOpt = {
		prologue: function () {
			var info = document.createElement('div');
			info.id = 'info-mark';
			info.className = 'info-script-display-init';

			info.innerHTML = infoSource;

			document.body.appendChild(info);
		},
		bePatient: {
			styleBody: {
				border: '1px solid #666',
				backgroundColor: '#eee',
				color: '#666'
			},
			message: 'Initializing...'
		},
		info: {
			mark: {
				classNameInit:	'info-script-display-init',
				className:	'info-script-display-block'
			}
		},
		setinfo: {
			waitIn:	5000
		}
	};
	_fss.tag.prototype.styleContainer = { position: 'absolute', zIndex: '1' }; // Safari needs z-index: 1
	ssuo = new _ssu(function () {
		buildingCeLIST = 0; // init
		main1();

		suo2 = new waitingTag('Reading CeLIST...',
			function () {
				oCeLIST = new buildCeLIST();
				if (oCeLIST.fail) return;
				main2();
				if (showingCopyright) { // not timed out
				}
				else { // already timed out
					oCeLIST.browsingPreface();
				}

				oReorganizedCeLIST = null; // init
				genv = {};
			});
	},ssuOpt);

	bpBody = ssuo.opt.bePatient.styleBody;
	bpSilhouette = ssuo.opt.bePatient.styleSilhouette;

	return !ssuo.available;
}
//-fxref-// clsb: _ssu
// ----------------------------------------------------------------
function removeCeLIST() {

	if (typeof CeLISTBrowser != 'undefined') { // restart
		for (var i = 0; i < document.body.childNodes.length; i++) {
			var x = document.body.childNodes[i];
			if (document.$ini && x == document.$ini.maintenance
				|| x.id == CeLISTBrowser._fssElementIdToBeInserted) {
				continue;
			}
			while (x.firstChild) x.removeChild(x.firstChild);
		}
	}
}
// ----------------------------------------------------------------
function clsbTerm() {
	removeCeLIST();
}
// ----------------------------------------------------------------
function clsbInit() {

	removeCeLIST();

	if (startUp()) {
		alert('Sorry.  W3C DOM compliant browser required!');
		return false;
	}

	if (!document.$ini) {
		document.$ini = {};
	}

	if (/^file:/i.test(document.URL)) { // only local

document.onkeypress = function (e) {

	var code;
	if (!e) var e = window.event;
	if (e.keyCode) code = e.keyCode;
	else if (e.which) code = e.which;

	if (code == 27 && e.shiftKey) {
		if (this.$ini.fileSelectMode ^= 1) {
			if (this.$ini.maintenance == undefined) {
				this.$ini.maintenance = document.createElement('div');
				_fss.setStyleSheetData(this.$ini.maintenance,{
					zIndex: '2',
					visibility: 'hidden',
					position: 'absolute',
					top: '4em',
					left: '25em'
				});
				document.body.appendChild(this.$ini.maintenance);

				this.$ini.maintenance.$f = createForm('sel','sub');
				_fss.setStyleSheetData(this.$ini.maintenance.$f,{
					margin: '0',
					padding: '0'
				});
				this.$ini.maintenance.appendChild(this.$ini.maintenance.$f);
				this.$ini.maintenance.$f.onsubmit = function () {
					document.fileCeLIST = this['sel'].value;
					document.$ini.maintenance.$lput('set file:'+document.fileCeLIST);
					clsbInit();
					return false;
				};

				// log
				this.$ini.maintenance.$log = document.createElement('div');
				_fss.setStyleSheetData(this.$ini.maintenance.$log,{
					backgroundColor: '#ffc',
					border: '1px inset #ffc',
					padding: '0.5em'
				});
				this.$ini.maintenance.appendChild(this.$ini.maintenance.$log);
				this.$ini.maintenance.$lput = function (str) {
					this.$log.appendChild(document.createTextNode(str));
					this.$log.appendChild(document.createElement('br'));
				}
				this.$ini.maintenance.$lput('maintenace mode started');
			}
			this.$ini.maintenance.style.visibility = 'visible';
		}
		else {
			this.$ini.maintenance.style.visibility = 'hidden';
		}
		document.body.style.backgroundColor = '#fcc';
	}
};

	}
	return true;
}
//-fxref-// clsb: _fss.setStyleSheetData

function createForm(selName,subName) {
	form = document.createElement('form');

	var ip = document.createElement('input');
	ip.setAttribute('type','file');
	ip.setAttribute('id',selName);
	ip.setAttribute('name',selName);

	var sub = document.createElement('input');
	sub.setAttribute('type','submit');
	sub.setAttribute('id',subName);
	sub.setAttribute('name',subName);
	sub.setAttribute('value','Read and start browsing');

	form.appendChild(document.createTextNode('CeLIST:'));
	form.appendChild(ip);
	form.appendChild(sub);

	return form;
}
